<script language="php">
///////////////////////////////////////////////////////////////////////////////
// OBM - File : host_display.php                                             //
//     - Desc : Host Display File                                            //
// 2004-09-09 Pierre Baudracco                                               //
///////////////////////////////////////////////////////////////////////////////
// $Id: host_display.inc 5653 2009-12-22 07:44:06Z david $
///////////////////////////////////////////////////////////////////////////////

//------------------------------------//
// Fields that appear in result lists //
//------------------------------------//
// Direct fields
$fieldnames['host_name'] = $l_name;
$fieldnames['host_delegation'] = $l_delegation;
$fieldnames['host_ip'] = $l_ip;
$fieldnames['host_samba'] = $l_smb;
$fieldnames['host_imap'] = $l_imap;
$fieldnames['host_smtp_in'] = $l_smtp_in;
$fieldnames['host_smtp_out'] = $l_smtp_out;
$fieldnames['host_obm_sync'] = $l_obm_sync;
$fieldnames['host_monitor'] = $l_monitor;
$fieldnames['host_description'] = $l_desc;
$fieldnames['usercreate'] = $l_creator;
$fieldnames['userupdate'] = $l_updater;
$fieldnames['timecreate'] = $l_date_creation;
$fieldnames['timeupdate'] = $l_date_last_update;


///////////////////////////////////////////////////////////////////////////////
// Display Host specific dataset fields
// Parameters:
//   - $OD        : OBM_DISPLAY object (passed by reference)
//   - $fieldname : field to display
//   - $link_ok   : true if links must be displayed
// Returns:
//   - $res : hash with 'name', 'url', 'align' values
///////////////////////////////////////////////////////////////////////////////
function dis_data_host(&$OD, $fieldname, $link_ok) {
  global $path ;

  if (($fieldname == 'host_name') && $link_ok) {
    if ($OD->display_ext == 'get_id') {
      $res['url'] = "javascript:check_get_id(".$OD->data_set->f('host_id').",'".addslashes($OD->data_set->f('host_name'))."');";
    } else {
     $res['url'] = "$path/host/host_index.php?action=detailconsult&amp;host_id=".$OD->data_set->f('host_id');
    }
  }

  else if ($fieldname == 'host_smtp_in') {
    $res['align'] = 'center';
    if ($OD->data_set->f($fieldname)) {
      $res['name'] = 'X';
    } else {
      $res['name'] = ' ';
    }
  }

  else if ($fieldname == 'host_smtp_out') {
    $res['align'] = 'center';
    if ($OD->data_set->f($fieldname)) {
      $res['name'] = 'X';
    } else {
      $res['name'] = ' ';
    }
  }

  else if ($fieldname == 'host_obm_sync') {
    $res['align'] = 'center';
    if ($OD->data_set->f($fieldname)) {
      $res['name'] = 'X';
    } else {
      $res['name'] = ' ';
    }
  }

  else if ($fieldname == 'host_imap') {
    $res['align'] = 'center';
    if ($OD->data_set->f($fieldname)) {
      $res['name'] = 'X';
    } else {
      $res['name'] = ' ';
    }
  }

  else if ($fieldname == 'host_samba') {
    $res['align'] = 'center';
    if ($OD->data_set->f($fieldname)) {
      $res['name'] = 'X';
    } else {
      $res['name'] = ' ';
    }
  }
  else if ($fieldname == 'host_monitor') {
    $res['align'] = 'center';
    if ($OD->data_set->f($fieldname)) {
      $res['name'] = 'X';
    } else {
      $res['name'] = ' ';
    }
  }

  return $res;
}


///////////////////////////////////////////////////////////////////////////////
// Display Host search Form
// Parameters : 
//   - $host[]   : default form values
//     keys used : name, user
///////////////////////////////////////////////////////////////////////////////
function html_host_search_form($host) {
  global $display, $l_name, $l_ip, $l_smb_only, $l_find;
  global $cgp_use, $obm;

  $popup = $host['popup'];

  if ($popup) {
    $ext_action = $host['ext_action'];
    $ext_target = $host['ext_target'];
    $ext_widget = $host['ext_widget'];
    $ext_widget_text = $host['ext_widget_text'];
    $ext_url = $host['ext_url'];
    $ext_id = $host['ext_id'];
    $ext_title = $host['ext_title'];
    $ext = "<input name=\"ext_action\" type=\"hidden\" value=\"$ext_action\">
      <input name=\"ext_id\" type=\"hidden\" value=\"$ext_id\">
      <input name=\"ext_target\" type=\"hidden\" value=\"$ext_target\">
      <input name=\"ext_widget\" type=\"hidden\" value=\"$ext_widget\">
      <input name=\"ext_widget_text\" type=\"hidden\" value=\"$ext_widget_text\">
      <input name=\"ext_title\" type=\"hidden\" value=\"$ext_title\">
      <input name=\"ext_url\" type=\"hidden\" value=\"$ext_url\">";
    if ($ext_title == '') {
      $ext_title = $l_add_hosts;
    }
    $display['title'] = $ext_title;
  }

  // Check if domain is a samba domain
  $samba_domain = false;
  if ($cgp_use['service']['samba']) {
    $props = of_entity_get_service_property('domain', $obm['domain_id']);
    if (is_array($props['samba']) && (count($props['samba']) > 0)) {
      $samba_domain = true;
    }
  }

  // --- Var preparation ------------------------------------------------------

  $name = stripslashes($host['name']);
  $delegation = stripslashes($host['delegation']);
  $ip = stripslashes($host['ip']);
  $smb = ($host['samba'] == '1' ? "checked = \"checked\"" : '');
  $smtp_in = ($host['smtp_in'] == '1' ? "checked = \"checked\"" : '');
  $smtp_out = ($host['smtp_out'] == '1' ? "checked = \"checked\"" : '');
  $obm_sync = ($host['obm_sync'] == '1' ? "checked = \"checked\"" : '');
  $solr = ($host['solr'] == '1' ? "checked = \"checked\"" : '');
  $imap = ($host['imap'] == '1' ? "checked = \"checked\"" : '');
  $monitor = ($host['monitor'] == '1' ? "checked = \"checked\"" : '');
  $imap_frontend = ($host['imap_frontend'] == '1' ? "checked = \"checked\"" : '');


  $dis_delegation = of_delegation_dis_search_form($delegation);

  // --- HTML Page display ----------------------------------------------------

  if (($cgp_use['service']['samba'])  && ($samba_domain)) {
    $block_samba = "
    <label>$l_smb_only<br />
      <input type=\"checkbox\" name=\"cb_samba\" value=\"1\" $smb />
    </label>";
  }
  if ($cgp_use['service']['mail']) {
    $block_mail = "
    <label>$GLOBALS[l_imap]<br />
      <input type=\"checkbox\" name=\"cb_imap\" value=\"1\" $imap />
    </label>
    <label>$GLOBALS[l_smtp_in]<br />
      <input type=\"checkbox\" name=\"cb_smtp_in\" value=\"1\" $smtp_in />
    </label>
    <label>$GLOBALS[l_smtp_out]<br />
      <input type=\"checkbox\" name=\"cb_smtp_out\" value=\"1\" $smtp_out />
    </label>
    <label>$GLOBALS[l_imap_frontend]<br />
      <input type=\"checkbox\" name=\"cb_imap_frontend\" value=\"1\" $imap_frontend />
    </label>";
  }
  if ($cgp_use['service']['sync']) {
    $block_sync = "
    <label>$GLOBALS[l_obm_sync]<br />
      <input type=\"checkbox\" name=\"cb_obm_sync\" value=\"1\" $obm_sync />
    </label>";
  }

  $block_solr = "
  <label>$GLOBALS[l_solr]<br />
    <input type=\"checkbox\" name=\"cb_solr\" value=\"1\" $solr />
  </label>";

  $block = "
    <form method=\"get\" name=\"f_search\" class=\"search\" action=\"".url_prepare("host_index.php")."\">
    <div class=\"search\">
      <label>$l_name<br />
        <input name=\"tf_name\" size=\"24\" maxlength=\"32\" value=\"$name\" />
      </label>
      $dis_delegation
      <label>$l_ip<br />
        <input name=\"tf_ip\" size=\"16\" maxlength=\"16\" value=\"$ip\" />
      </label>
      $block_samba
      $block_mail
      $block_sync
      $block_solr
      <label>$GLOBALS[l_monitor]<br />
        <input type=\"checkbox\" name=\"cb_monitor\" value=\"1\" $monitor />
      </label>
      <label>&nbsp;<br />
        <input name=\"action\" type=\"hidden\" value=\"search\" />
        <input name=\"popup\" type=\"hidden\" value=\"$popup\" />
        <input name=\"submit\" type=\"submit\" value=\"$l_find\" />
        $ext
      </label>
      <p class=\"CL\" />
    </div>
  </form>";

  return $block;
}


/**
 * Display the Host search result
 *
 * @param mixed $host[] : host search criteria
 * @return Search result display
 */
function dis_host_search_list($host) {
  global $l_found, $l_no_found, $display, $obm;

  $prefs = get_display_pref($obm['uid'], 'host');
  $obm_q = run_query_host_search($host);

  $nb_host = $obm_q->num_rows_total();
  if ($nb_host == 0) {
    $display['msg'] .= display_warn_msg($l_no_found);
  } else {
    $display['msg'] .= display_ok_msg("$nb_host $l_found");
    $block = html_host_search_list($obm_q, $prefs, $host);
  }

  return $block;
}


/**
 * XHTML Display the Host search result
 *
 * @param mixed $obm_q  : database object with host list
 * @param mixed $pref_q : database object with user display preferences
 * @param mixed $host[] : host parameters
 * @return XHTML Display Search result
 */
function html_host_search_list($obm_q, $pref_q, $host) {
  global $display, $l_found, $l_close, $module;

  $popup = $host['popup'];

  if ($popup) {
    $ext_action = $host['ext_action'];
    $ext_url = $host['ext_url'];
    $ext_target = $host['ext_target'];
    $ext_widget = $host['ext_widget'];
    $ext_widget_text = $host['ext_widget_text'];
    $ext_id = $host['ext_id'];
    $ext_title = urlencode(stripslashes($host['ext_title']));
    $url_ext = "&amp;ext_action=$ext_action&amp;ext_url=$ext_url&amp;ext_id=$ext_id&amp;ext_title=$ext_title&amp;ext_target=$ext_target&amp;ext_widget=$ext_widget&amp;ext_widget_text=$ext_widget_text&amp;popup=1";
  }

  $name = urlencode(stripslashes($host['name']));
  $delegation = urlencode(stripslashes($host['delegation']));
  $ip = urlencode(stripslashes($host['ip']));
  $smb = $host['samba'];
  $imap = $host['imap'];
  $smtp_in = $host['smtp_in'];
  $smtp_out = $host['smtp_out'];
  $obm_sync = $host['obm_sync'];
  $solr = $host['solr'];
  $monitor = $host['monitor'];


  $url = url_prepare("host_index.php?action=search&amp;tf_name=$name&amp;tf_delegation=$delegation&amp;tf_ip=$ip&amp;cb_samba=$smb&amp;cb_imap=$imap&amp;cb_smtp_in=$smtp_in&amp;cb_smtp_out=$smtp_out&amp;cb_obm_sync=$obm_sync&amp;cb_solr=$solr&amp;cb_monitor=$monitor$url_ext");

  $dis_host = new OBM_DISPLAY('DATA', $pref_q, $module);

  if ($popup) {
    if ( ($ext_widget != '') && ($ext_widget_text != '') ) { 
      $dis_host->display_ext = 'get_id';
    }
    $dis_host->data_form_end = "
      <p>
      <a href=\"\" onclick='window.close();'>$l_close</a>
      </p>";
  }
  
  $dis_host->data_set = $obm_q;
  $dis_host->data_url = $url;

  // --- HTML Template --------------------------------------------------------
  $block .= $dis_host->display('dis_data_host');

  return $block;
}


/**
 * Display Host Detail
 *
 * @param mixed $host[] : host parameters
 * @return Display block
 */
function dis_host_consult($host) {
  global $display, $l_err_reference;

  $host_q = run_query_host_detail($host['host_id']);
  if ($host_q->num_rows() == 1) {
    $block = html_host_consult($host_q);
  } else {
    $display['msg'] .= display_err_msg($l_err_reference);
  }

  return $block;
}


/**
 * XHTML Display Host Detail
 *
 * @param mixed $host_q : host database data
 * @return XHTML Display block
 */
function html_host_consult($host_q) {
  global $cgp_use, $obm, $display, $perm, $menu, $action, $cright_write;
  global $l_yes, $l_no, $l_module_host, $l_name, $l_ip, $l_desc, $l_smb;
  global $l_perms, $l_enable, $l_disable, $l_empty, $l_not_assigned;
  global $l_user, $l_fqdn, $l_system, $l_help_system,$l_domain;
  global $l_module_monitoring, $l_day, $l_week, $l_month, $l_year;

  // Check if domain is a samba domain
  $samba_domain = false;
  if ($cgp_use['service']['samba']) {
    $props = of_entity_get_service_property('domain', $obm['domain_id']);
    if (is_array($props['samba']) && (count($props['samba']) > 0)) {
      $samba_domain = true;
    }
  }

  $id = $host_q->f('host_id');
  $delegation = $host_q->f('host_delegation');
  $samba = $host_q->f('host_samba');
  $imap = $host_q->f('host_imap');
  $smtp_out = $host_q->f('host_smtp_out');
  $obm_sync = $host_q->f('host_obm_sync');
  $solr = $host_q->f('host_solr');
  $imap_frontend = $host_q->f('host_imap_frontend');
  $smtp_in = $host_q->f('host_smtp_in');
  $monitor = $host_q->f('host_monitor');
  $name = $host_q->f('host_name');
  $desc = $host_q->f('host_description');
  $ip = $host_q->f('host_ip');
  $fqdn = $host_q->f('host_fqdn');
  $user_id = $host_q->f('userobm_id');
  $user_login = $host_q->f('userobm_login');
  $domain_name = ($host_q->f('domain_name') != '' ? $host_q->f('domain_name') : 'GLOBAL');

  $dis_user =   
    "<tr>
      <th>$l_user</th>
      <td>$dis_user</td>
    </tr>";

  // Formatage des informations de la BD
  if ($samba) $samba = $l_yes; else $samba = $l_no;
  if ($imap) $imap = $l_yes; else $imap = $l_no;
  if ($smtp_in) $smtp_in = $l_yes; else $smtp_in = $l_no;
  if ($smtp_out) $smtp_out = $l_yes; else $smtp_out = $l_no;
  if ($obm_sync) $obm_sync = $l_yes; else $obm_sync = $l_no;
  if ($solr) $solr = $l_yes; else $solr = $l_no;
  if ($imap_frontend) $imap_frontend = $l_yes; else $imap_frontend = $l_no;
  if ($monitor) $monitor = $l_yes; else $monitor = $l_no;
  if ($user_login == '') {
    $dis_user = $l_not_assigned;
  } else {
    $dis_user = "<a href=\"$path/user/user_index.php?action=detailconsult&amp;user_id=$user_id\">$user_login</a>";
  }
  if ($mail_server) $mail_server = $l_yes; else $mail_server = $l_no;

  $block_delegation = of_delegation_dis_block_consult($delegation);
    

  $display['detailInfo'] = display_record_info($host_q);
  $display['title'] = $name;

  if (($cgp_use['service']['samba']) && ($samba_domain)) {
    $block_samba = "
    <tr>
      <th>$l_smb</th>
      <td>$samba</td>
    </tr>";
  }

  if ($cgp_use['service']['mail']) {
    $block_mail = "
    <tr>
      <th>$GLOBALS[l_imap]</th>
      <td>$imap</td>
    </tr>
    <tr>
      <th>$GLOBALS[l_smtp_in]</th>
      <td>$smtp_in</td>
    </tr>
    <tr>
      <th>$GLOBALS[l_smtp_out]</th>
      <td>$smtp_out</td>
    </tr>
    <tr>
      <th>$GLOBALS[l_imap_frontend]</th>
      <td>$imap_frontend</td>
    </tr>
      ";    
  }

  if ($cgp_use['service']['sync']) {
    $block_sync = "
    <tr>
      <th>$GLOBALS[l_obm_sync]</th>
      <td>$obm_sync</td>
    </tr>
      ";    
  }

  $block_solr = "
  <tr>
    <th>$GLOBALS[l_solr]</th>
    <td>$solr</td>
  </tr>";    

  $host_domain_explode = explode('.', $fqdn, 2 );
  $host_domain = $host_domain_explode[1];
  $graph_list = get_host_graph_list($fqdn);
  
  if ( $graph_list[0] !== NULL ){
    $block_stat_menu .=  "
      <div id='stat_menu'>
      <ul>
      ";
    foreach ( $graph_list as $graph){
      $block_stat_menu .= "
        <li> <a href=# title='".$graph."'>".$graph."</a></li>
        ";
    }
    $block_stat_menu .= "
      </ul>
      </div>
      ";

    $block_stat = "
     <h1>$l_module_monitoring</h1>
      <div id=\"menuDay\" >
        <a href=# title='day'>
          ".$l_day."
        </a>
        <a href=# title='week'>
          ".$l_week."
        </a>
        <a href=# title='month'>
          ".$l_month."
        </a>
        <a href=# title='year'>
          ".$l_year."
        </a>
      </div> 
      ".$block_stat_menu."
      <div id='stat_img'>
        <img src=/stats/$host_domain/$fqdn-$graph_list[0]-day.png>
      </div>
      ";
    }



  $block = "
    <div class=\"detail extras\">
    <h1>$l_module_host</h1>

    <table>
    <tr>
      <th>$l_name</th>
      <td>$name</td>
    </tr>
    <tr>
      <th>$l_domain</th>
      <td>$domain_name</td>
    </tr>
    $block_delegation
    <tr>
      <th>$l_fqdn</th>
      <td>$fqdn</td>
    </tr>    
    <tr>
      <th>$l_ip</th>
      <td>$ip</td>
    </tr>
    $block_samba
    <tr>
      <th>$l_desc</th>
      <td>$desc</td>
    </tr>

    $block_mail
    $block_sync
    $block_solr
    <tr>
      <th>$GLOBALS[l_monitor]</th>
      <td>$monitor</td>
    </tr>
    </table>
    $block_stat
    </div>";

  return $block;
}



///////////////////////////////////////////////////////////////////////////////
// Display Host Form
// Parameters :
//   - $action   : action called
//   - $host_q   : DBO : information about the host (null for new host)
//   - $host[]   : default or transmitted values
//     keys used : name, desc, usercreate
//   - $field    : field in error
///////////////////////////////////////////////////////////////////////////////
function html_host_form($action, $host_q, $host, $field='') {
  global $cgp_use, $l_domain, $l_insert, $l_update, $l_back;
  global $l_module_host, $l_name, $l_desc, $l_ip, $l_smb;
  global $l_perms, $l_header_new, $l_fqdn;
  global $l_host_select_user, $l_user, $l_clear;
  global $ico_user, $display, $obm, $c_services;
  
  // Check if domain is a samba domain
  $samba_domain = false;
  if ($cgp_use['service']['samba']) {
    $props = of_entity_get_service_property('domain', $obm['domain_id']);
    if (is_array($props['samba']) && (count($props['samba']) > 0)) {
      $samba_domain = true;
    }
  }

  // if update mode and first time, values are taken from db
  if ($action == 'detailupdate') {
    $id = $host_q->f('host_id');
    $name = $host_q->f('host_name');
    $delegation = $host_q->f('host_delegation');
    $ip = $host_q->f('host_ip');
    $fqdn = $host_q->f('host_fqdn');
    $samba = $host_q->f('host_samba');
    $imap = $host_q->f('host_imap');
    $smtp_in = $host_q->f('host_smtp_in');
    $smtp_out = $host_q->f('host_smtp_out');
    $obm_sync = $host_q->f('host_obm_sync');
    $solr = $host_q->f('host_solr');
    $imap_frontend = $host_q->f('host_imap_frontend');
    $monitor = $host_q->f('host_monitor');
    $desc = $host_q->f('host_description');
    $u_login = $host_q->f('userobm_login');
    $u_id = $host_q->f('userobm_id');
    $dis_title = $name;
  } else if ($action == 'new') {
    // If windows domain, default check the windows checkbox
    if ($samba_domain) {
      $samba = 1;
    }
  }

  // If parameters have been given, they supercede the default action value
  if (isset($host['host_id'])) { $id = $host['host_id']; }
  if (isset($host['name'])) { $name = stripslashes($host['name']); }
  if (isset($host['delegation'])) { $delegation = stripslashes($host['delegation']); }
  if (isset($host['ip'])) { $ip = $host['ip']; }
  if (isset($host['fqdn'])) { $fqdn = $host['fqdn']; }
  if (isset($host['samba'])) { $samba = $host['samba']; }
  if (isset($host['imap'])) { $imap = $host['imap']; }
  if (isset($host['smtp_in'])) { $smtp_in = $host['smtp_in']; }
  if (isset($host['smtp_out'])) { $smtp_out = $host['smtp_out']; }
  if (isset($host['obm_sync'])) { $obm_sync = $host['obm_sync']; }
  if (isset($host['solr'])) { $solr = $host['solr']; }
  if (isset($host['imap_frontend'])) { $imap_frontend = $host['imap_frontend']; }
  if (isset($host['monitor'])) { $monitor = $host['monitor']; }
  if (isset($host['desc'])) { $desc = stripslashes($host['desc']); }
  if (isset($host['domain_id'])) { $domain_id = $host['domain_id']; }

  // Domain (can't be updated, so only on insert)
  if (($action == 'new' || $action == 'insert')
      && $obm['domain_global']) {
    $sel_domain_id = of_domain_dis_select($domain_id);
    $dis_domain = "<tr>
      <th>$l_domain</th>
      <td>$sel_domain_id</td>
    </tr>";
  }
  // Samba host checkbox checked value
  $samba_state  = ($samba ? 'checked' : '');
  $imap_state  = ($imap ? 'checked' : '');
  $smtp_in_state  = ($smtp_in ? 'checked' : '');
  $smtp_out_state  = ($smtp_out ? 'checked' : '');
  $obm_sync_state  = ($obm_sync ? 'checked' : '');
  $solr_state  = ($solr ? 'checked' : '');
  $imap_frontend_state  = ($imap_frontend ? 'checked' : '');
  $monitor_state  = ($monitor ? 'checked' : '');


  // Mark the error field
  if ($field != '') {
    $class[$field] = 'error';
  }

  $block_delegation = of_delegation_dis_block_update($delegation, $class['delegation']);

  $display['detailInfo'] = display_record_info($host_q);
  $display['title'] = $dis_title;
  if ($action != 'insert' && $action !='new') {
    $dis_name = "$name <input type=\"hidden\" name=\"tf_name\" maxlength=\"32\" size=\"32\" value=\"$name\" />";
  } else {
    $dis_name = "<input name=\"tf_name\" maxlength=\"32\" size=\"32\" value=\"$name\" />";
  }

  // Display windows info only if samba is active and domainis samba
  if (($cgp_use['service']['samba']) && ($samba_domain)) {
    $block_samba = "
    <tr>
      <th class=\"$class[samba]\"><label for=\"cb_samba\">$l_smb</label></th>
      <td>
        <input id=\"cb_samba\" name=\"cb_samba\" type=\"checkbox\" value=\"1\" $samba_state>
      </td>
    </tr>";
  }
  if ($cgp_use['service']['mail']) {
    $block_mail = "
    <tr>
      <th class=\"$class[imap]\"><label for=\"cb_imap\">$GLOBALS[l_imap]</label></th>
      <td>
        <input id=\"cb_imap\" name=\"cb_imap\" type=\"checkbox\" value=\"1\" $imap_state>
      </td>
    </tr><tr>
      <th class=\"$class[smtp_in]\"><label for=\"cb_smtp_in\">$GLOBALS[l_smtp_in]</label></th>
      <td>
        <input id=\"cb_smtp_in\" name=\"cb_smtp_in\" type=\"checkbox\" value=\"1\" $smtp_in_state>
      </td>
    </tr><tr>
      <th class=\"$class[smtp_out]\"><label for=\"cb_smtp_out\">$GLOBALS[l_smtp_out]</label></th>
      <td>
        <input id=\"cb_smtp_out\" name=\"cb_smtp_out\" type=\"checkbox\" value=\"1\" $smtp_out_state>
      </td>
    </tr><tr>
      <th class=\"$class[imap_frontend]\"><label for=\"cb_imap_frontend\">$GLOBALS[l_imap_frontend]</label></th>
      <td>
        <input id=\"cb_imap_frontend\" name=\"cb_imap_frontend\" type=\"checkbox\" value=\"1\" $imap_frontend_state>
      </td>
    </tr>";
  }
  if ($cgp_use['service']['sync']) {
    $block_sync = "
    <tr>
      <th class=\"$class[obm_sync]\"><label for=\"cb_obm_sync\">$GLOBALS[l_obm_sync]</label></th>
      <td>
        <input id=\"cb_obm_sync\" name=\"cb_obm_sync\" type=\"checkbox\" value=\"1\" $obm_sync_state>
      </td>
    </tr>";
  }

  $block_solr = "
  <tr>
    <th class=\"$class[solr]\"><label for=\"cb_solr\">$GLOBALS[l_solr]</label></th>
    <td>
      <input id=\"cb_solr\" name=\"cb_solr\" type=\"checkbox\" value=\"1\" $solr_state>
    </td>
  </tr>";

  $dis_user = "
  <tr>
  <th class=\"$class[user]\">
  $l_user
  <a href=\"\" onclick=\"popup('$path/user/user_index.php?action=ext_get_id&amp;popup=1&amp;ext_title=".urlencode($l_host_select_user)."&amp;ext_widget=f_host.user_id&amp;ext_widget_text=f_host.tf_user_login','User'); return false;\">
   <img src=\"$ico_user\" alt=\"\" /></a>
  </th>
   
    <td>
    <input type=\"hidden\" name=\"user_id\" value=\"$u_id\" />
    <input type=\"text\" name=\"tf_user_login\" value=\"$u_login\" readonly=\"readonly\" onfocus=\"this.blur();\" />
    <input type=\"button\" value=\"$l_clear\" onclick=\"this.form.user_id.value='';this.form.tf_user_login.value='';\" />
    </td>
  </tr>";

  $block = "
  <form method=\"get\" name=\"f_host\" action=\"host_index.php\">

  <fieldset class=\"detail extras\">
  <legend>$l_module_host</h1>

  <table>
  <tr>
    <th class=\"$class[name]\">$l_name</th>
    <td>
    $dis_name
    </td>
  </tr>
  $dis_domain
  $block_delegation
  <tr>
    <th class=\"$class[ip]\">$l_ip</th>
    <td>
      <input name=\"tf_ip\" maxlength=\"16\" size=\"16\" value=\"$ip\" /></td>
  </tr>
  <tr>
    <th class=\"$class[fqdn]\">$l_fqdn</th>
    <td>
      <input name=\"tf_fqdn\" value=\"$fqdn\" /></td>
  </tr>  
  $block_samba
  $block_mail
  $block_sync
  $block_solr
   <tr>
     <th class=\"$class[monitor]\"><label for=\"cb_monitor\">$GLOBALS[l_monitor]</label></th>
     <td>
       <input id=\"cb_monitor\" name=\"cb_monitor\" type=\"checkbox\" value=\"1\" $monitor_state>
     </td>
   </tr>
  <tr>
    <th class=\"$class[desc]\">$l_desc</th>
    <td>
      <input name=\"tf_desc\" value=\"$desc\" size=\"32\" maxlength=\"128\" />
    </td>
  </tr>

  </table>
  </fieldset>";

  if (($action == 'detailupdate') || ($action == 'update')) {
    $dis_but = "
      <input type=\"hidden\" name=\"host_id\" value=\"$id\" />
      <input type=\"hidden\" name=\"action\" value=\"update\" />
      <input type=\"submit\" value=\"$l_update\" />";

  } else {
    $dis_but .= "<input type=\"hidden\" name=\"action\" value=\"insert\" />
      <input type=\"submit\" value=\"$l_insert\" />";
  }

  $block .= "<fieldset class=\"buttons\">
    $dis_but
    </fieldset>
    </form>";

  return $block;
}


///////////////////////////////////////////////////////////////////////////////
// Display the Host Display preference screen
// Parameters:
//   - $prefs : Display preferences
///////////////////////////////////////////////////////////////////////////////
function dis_host_display_pref($prefs) {
  global $l_host_display, $module;

  $dis_pref = new OBM_DISPLAY('PREFERENCES', $prefs, $module);
  $dis_pref->display_entity = 'host'; 
  $dis_pref->pref_title = $l_host_display;
  $dis_pref->pref_dis_help = 1;

  $block = $dis_pref->display();

  return $block;
}


///////////////////////////////////////////////////////////////////////////////
// Display warning before a host deletion
// We ask confirmation or cancel
// Parameters:
//   - $id : host id
///////////////////////////////////////////////////////////////////////////////
function dis_host_warn_delete($id) {
  global $display, $l_warn_delete, $l_delete, $l_can_delete, $l_back;

  $lhost = get_host_info($id);
  $display['msg'] .= display_info_msg("$l_can_delete");

   $dis_delete = "
   <p class=\"detailButtons\">
    <form method=\"get\" name=\"form_delete\"
    action=\"" .url_prepare("host_index.php") . "\">
    <input type=\"hidden\" name=\"action\" value=\"delete\" />
    <input type=\"hidden\" name=\"host_id\" value=\"$id\" />
    <input type=\"submit\" name=\"submit\" value=\"$l_delete\" />
    </form>
   </p>";

  $dis_back = "
    <p class=\"detailButtons\">
      <form name=\"form_back\" method=\"get\"
      action=\"" .url_prepare("host_index.php") . "\">
      <input type=\"hidden\" name=\"action\" value=\"detailconsult\" />
      <input type=\"hidden\" name=\"host_id\" value=\"$id\" />
      <input type=\"submit\" value=\"$l_back\" />
      </form>
    </p>";

  $block = "
  <div class=\"detailButton\">
    $dis_delete
    $dis_back
  </div>";

  return $block;
}


///////////////////////////////////////////////////////////////////////////////
// Display the context about a host insertion or update
// When similar hosts exist we show these and ask confirmation
// Parameters:
//   - $id       : host id
//   - $h_q      : host database result (at least 1 row)
//   - $host[]  : values for insertion/update (if confirmation)
//     keys used : name, desc
/////////////////////////////////////////////////////////////////////////////
function dis_host_warn_insert($id, $h_q, $host) {
  global $display, $l_check_samehost, $l_confirm, $l_back;
  global $c_yes, $c_no;

  $name = $host['name'];
  $delegation = $host['delegation'];
  $ip = $host['ip'];
  $desc = $host['desc'];
  $fqdn = $host['fqdn'];
  $imap = $host['imap'];
  $smtp_in = $host['smtp_in'];
  $smtp_out = $host['smtp_out'];
  $obm_sync = $host['obm_sync'];
  $solr = $host['solr'];
  $imap_frontend = $host['imap_frontend'];
  $samba = $host['samba'];

  $display['msg'] .= display_warn_msg($l_check_samehost);
  while ($h_q->next_record()) {
    $id = $h_q->f('host_id');
    $samename = $h_q->f('host_name');
    $samedesc = $h_q->f('host_description');
    $dis_same_host .= "
      <li>
        <a href=\"" .url_prepare("host_index.php?action=detailconsult&amp;host_id=$id") . "\">$samename ($samedesc)</a>
      </li>";
  }

  $hidden_fields = "
    <input type=\"hidden\" name=\"tf_name\" value=\"$name\" />
    <input type=\"hidden\" name=\"tf_delegation\" value=\"$delegation\" />
    <input type=\"hidden\" name=\"tf_ip\" value=\"$ip\" />
    <input type=\"hidden\" name=\"cb_imap\" value=\"$imap\" />
    <input type=\"hidden\" name=\"cb_smtp_in\" value=\"$smtp_in\" />
    <input type=\"hidden\" name=\"cb_smtp_out\" value=\"$smtp_out\" />
    <input type=\"hidden\" name=\"cb_obm_sync\" value=\"$obm_sync\" />
    <input type=\"hidden\" name=\"cb_solr\" value=\"$solr\" />
    <input type=\"hidden\" name=\"cb_imap_frontend\" value=\"$imap_frontend\" />
    <input type=\"hidden\" name=\"cb_samba\" value=\"$samba\" />
    <input type=\"hidden\" name=\"tf_fqdn\" value=\"$fqdn\" />
    <input type=\"hidden\" name=\"tf_desc\" value=\"$desc\" />
";

  $block = "
  <div class=\"detail\">
    <ul>
    $dis_same_host
    </ul>
  </div>

  <div class=\"buttons\">
    <form method=\"post\" name=\"form_insert\"
    action=\"" .url_prepare("host_index.php") . "\">
    <input type=\"hidden\" name=\"action\" value=\"insert\" />
    <input type=\"hidden\" name=\"hd_confirm\" value=\"$c_yes\" />
    $hidden_fields
    <input type=\"submit\" name=\"submit\" value=\"$l_confirm\" />
    </form>

    <form name=\"form_back\" method=\"get\"
    action=\"" .url_prepare("host_index.php") . "\">
    <input type=\"hidden\" name=\"action\" value=\"new\" />
    $hidden_fields
    <input type=\"submit\" value=\"$l_back\" />
    </form>
  </div>";

  return $block;
}

</script>
